/*
 * $Id: sspec.h,v 1.1.2.1 1999/12/15 20:39:51 masaki Exp $
 */

#ifndef _SSPEC_H_
#define _SSPEC_H_

#ifdef sun
#include <sys/bitypes.h>
#endif

#define SSPEC_MTU_SIZE 1280

typedef struct _if_qos_t {
    u_int32_t pps;	/* packet per second */
    u_int32_t qos_pps;	/* qos pps */
    u_int32_t ann_pps;	/* announce pps */
    u_int32_t dly;	/* queue delay */
} if_qos_t;

typedef struct _link_qos_t {
    u_int8_t flag:1;	/* flag */
    u_int8_t pri:7;	/* priority */
    u_int8_t loh;	/* link overhead */
    u_int16_t rsvd;	/* pad */
    u_int32_t pps;	/* packet per second */
    u_int32_t dly;	/* transmission delay */
} link_qos_t;

typedef struct _area_qos_t {
    u_int8_t pri;	/* priority */
    u_int8_t rsvd1;	/* pad */
    u_int16_t rsvd2;	/* pad */
    u_int32_t ctu;	/* charging time unit */
    u_int32_t bfee;	/* base fee for each ctu */
    u_int32_t pfee;	/* fee per packet for each ctu */
} area_qos_t;


#define SRSVP_REQ_QOS_SIZE 28
typedef struct _req_qos_t {
    u_int8_t pri;	/* priority */
    u_int8_t rsvd;	/* pad */
    u_int16_t mtu;	/* maximum transmission unit */
    u_int32_t pps;	/* packet per second */
    u_int32_t sec;	/* second */
    u_int32_t cd;	/* coefficient for delay */
    u_int32_t cf;	/* coefficient for fee */
    u_int32_t rdly;	/* restricted delay */
    u_int32_t rfee;	/* restricted fee */
} req_qos_t;

typedef struct _path_qos_t {
    u_int32_t pps;	/* packet per second */
    u_int32_t dly;	/* transmission delay */
} path_qos_t;

#define SSPEC_PRI_EMERGENCY     0
#define SSPEC_PRI_LEASED        1
#define SSPEC_PRI_HIGH          2
#define SSPEC_PRI_USER          3

#define SSPEC_AGPPS 4000

#endif /* _SSPEC_H_ */
